## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global commit bca1359f3e168707ec663921925a1034ac8d90c8
%global snapdate 20240506

Name:           lexertl14
Summary:        The Modular Lexical Analyser Generator
Version:        0.1.0^%{snapdate}git%{sub %{commit} 1 7}
Epoch:          1
Release:        %autorelease

License:        BSL-1.0
URL:            https://github.com/BenHanson/lexertl14
Source:         %{url}/archive/%{commit}/lexertl14-%{commit}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  dos2unix

# No compiled binaries are installed, so this would be empty.
%global debug_package %{nil}

%global common_description %{expand:
This is the C++14 version of lexertl. Please prefer lexertl17 wherever
possible.}

%description %{common_description}


%package devel
Summary:        %{summary}

# Header-only library:
Provides:       lexertl14-static = %{epoch}:%{version}-%{release}
# https://docs.fedoraproject.org/en-US/packaging-guidelines/Conflicts/#_compat_package_conflicts
Conflicts:      lexertl17-devel

Provides:       lexertl14-examples = %{epoch}:%{version}%{release}
Obsoletes:      lexertl14-examples < 0.1.0^20240216git7a365a2-5

%description devel %{common_description}


%prep
%autosetup -n lexertl14-%{commit} -p1

# Fix line terminations (particularly for files that may be installed)
find . -type f -exec file '{}' '+' |
  grep -E '\bCRLF\b' |
  cut -d ':' -f 1 |
  xargs -r dos2unix --keepdate


%build
%cmake -DBUILD_TESTING:BOOL=ON -DBUILD_EXAMPLES:BOOL=ON
%cmake_build

# Make a copy of the examples directory without CMakeLists.txt files, which are
# not useful without the top-level CMakeLists.txt for the project.
mkdir _cleaned
cp -rvp examples _cleaned
find _cleaned/examples -type f -name CMakeLists.txt -print -delete


%install
%cmake_install


%check
%ctest


%files devel
%license include/lexertl/licence_1_0.txt
%doc README.md
%doc _cleaned/examples/

%{_includedir}/lexertl/

%{_libdir}/cmake/lexertl/


%changelog
## START: Generated by rpmautospec
* Mon Aug 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 1:0.1.0^20240506gitbca1359-2
- Bump Release, after Epoch bump

* Mon Aug 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 1:0.1.0^20240506gitbca1359-1
- Revert "Update to 0.1.0^20240527gitedd1183"
- Add an Epoch

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0^20240527gitedd1183-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Mon May 27 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240527gitedd1183-1
- Update to 0.1.0^20240527gitedd1183

* Fri May 17 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240506gitbca1359-1
- Update to 0.1.0^20240506gitbca1359

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240301git3097246-1
- Update to 0.1.0^20240301git3097246, with upstream fix for examples

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240216git7a365a2-6
- Add Conflicts with new lexertl17-devel

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240216git7a365a2-5
- Move the examples into the -devel subpackage

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240216git7a365a2-4
- Do not install useless CMakeLists.txt files with examples

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240216git7a365a2-3
- Ensure the examples actually compile

* Fri Feb 16 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20240216git7a365a2-1
- Update to 0.1.0^20240216git7a365a2

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0^20230910gitc045058-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0^20230910gitc045058-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Sep 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230910gitc045058-2
- Keep timestamps when converting text file line endings

* Mon Sep 11 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230910gitc045058-1
- Update to c045058 (multilib fixed upstream)

* Fri Sep 08 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230904git86c90c3-4
- Use a proper patch to fix multilib paths, and offer it upstream

* Tue Sep 05 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230904git86c90c3-2
- Improve the Summary

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230904git86c90c3-1
- Update to 86c90c3 (Restore the ability to run tests with BUILD_TESTING
  and ctest)

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230826git5bd3180-1
- Update to 5bd3180
- Changed from std::size_t to uint16_t for ease of use
- Added missing #include and functions
- regex macro BOL and EOL fixes
- Added exit state syntax check for missing right chevron

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230610gitc4bcaf8-1
- Update to c4bcaf8
- More SonarLint etc changes
- Applied SA changes
- Added tests

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230519git2e2893c-1
- Update to 2e2893c
- Added replace.hpp
- Now throwing exception in case of stack underflow
- Updated serialization support
- More use of auto
- Use cend()
- More UTF-32 support
- Added stream_num.hpp
- Fixed #include

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0^20230227gitaeddda8-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Mar 10 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20230227gitaeddda8-1
- Update to aeddda8 (Unicode 15.1.0 and other minor enhancements)

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0^20220919git8b8ead2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Dec 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20220919git8b8ead2-2
- Indicate dirs. in files list with trailing slashes

* Tue Sep 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20220919git8b8ead2-1
- Update to 8b8ead2 (Update to the latest Unicode standard)

* Fri Aug 05 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20220228gitcd5a1f1-3
- Update License to SPDX

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0^20220228gitcd5a1f1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Feb 28 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0^20220228gitcd5a1f1-1
- Drop “forge” macros; adapt to current snapshot versioning guidelines

* Mon Feb 28 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-6
- Update to cd5a1f1 (Unicode 15)

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-4
- Update to 2ea71b8

* Tue Dec 14 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-3
- Dep. on cmake-filesystem is now auto-generated

* Fri Nov 19 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-2
- Update to commit 488602f

* Wed Aug 25 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-1
- Initial package
## END: Generated by rpmautospec
